---
title: Introduction to formatting contexts
slug: Web/CSS/CSS_Flow_Layout/Intro_to_formatting_contexts
tags:
  - BFC
  - Block Formatting Context
  - CSS
  - Formatting contexts
  - Guide
  - Intermediate
  - Layout
  - flow
---
<div>{{CSSRef}}</div>

<p class="summary"><span class="seoSummary">This article introduces the concept of formatting contexts, of which there are several types, including block formatting contexts, inline formatting contexts, and flex formatting contexts. The basics of how they behave and how you can make use of these behaviors are also introduced.</span></p>

<p>Everything on a page is part of a <strong>formatting context</strong>, or an area which has been defined to lay out content in a particular way. A <strong>block formatting context</strong> (<abbr title="Block Formatting Context">BFC</abbr>) will lay child elements out according to block layout rules, a <strong>flex formatting context</strong> will lay its children out as {{Glossary("flex item", "flex items")}}, etc. Each formatting context has specific rules about how layout behaves when in that context.</p>

<h2 id="Block_formatting_contexts">Block formatting contexts</h2>

<p>The outermost element in a document that uses block layout rules establishes the first, or <strong>initial block formatting context</strong>. This means that every element inside the <code>&lt;html&gt;</code> element's block is laid out according to normal flow following the rules for block and inline layout. Elements participating in a <abbr title="Block Formatting Context">BFC</abbr> use the rules outlined by the CSS Box Model, which defines how an element's margins, borders, and padding interact with other blocks in the same context.</p>

<h3 id="Creating_a_new_block_formatting_context">Creating a new block formatting context</h3>

<p>The {{HTMLElement("html")}} element is not the only element capable of creating a block formatting context. Any block-level element can be made to create a BFC by the application of certain CSS properties.</p>

<p>A new BFC is created in the following situations:</p>

<ul>
 <li>elements made to float using {{cssxref("float")}}</li>
 <li>absolutely positioned elements (including {{cssxref("position", "position: fixed", "#fixed")}} or {{cssxref("position", "position: sticky", "#sticky")}})</li>
 <li>elements with {{cssxref("display", "display: inline-block", "#inline-block")}}</li>
 <li>table cells or elements with <code>display: table-cell</code>, including anonymous table cells created when using the <code>display: table-*</code> properties</li>
 <li>table captions or elements with <code>display: table-caption</code></li>
 <li>block elements where <code>overflow</code> has a value other than <code>visible</code></li>
 <li>elements with <code>display: flow-root</code> or <code>display: flow-root list-item </code></li>
 <li>elements with {{cssxref("contain", "contain: layout", "#layout")}}, <code>content</code>, or <code>strict</code></li>
 <li>{{Glossary("flex item", "flex items")}}</li>
 <li>grid items</li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Columns/Basic_Concepts_of_Multicol">multicol containers</a></li>
 <li>elements with {{cssxref("column-span")}} set to <code>all</code></li>
</ul>

<p>This is useful because a new BFC will behave much like the outermost document in that it becomes a mini-layout inside the main layout. A BFC contains everything inside it, {{cssxref("float")}} and {{cssxref("clear")}} only apply to items inside the same formatting context, and margins only collapse between elements in the same formatting context.</p>

<h3 id="BFC_creation_examples">BFC creation examples</h3>

<p>Let's have a look at a couple of these in order to see the effect creating a new <abbr title="Block Formatting Context">BFC</abbr>.</p>

<p>In the example below, we have a floated element inside a <code>&lt;div&gt;</code> with a border applied. The content of that <code>&lt;div&gt;</code> has floated alongside the floated element. As the content of the float is taller than the content alongside it, the border of the <code>&lt;div&gt;</code> now runs through the float. As explained in the <a href="/en-US/docs/Web/CSS/CSS_Flow_Layout/In_Flow_and_Out_of_Flow">guide to in-flow and out of flow elements</a>, the float has been taken out of flow so the background and border of the div only contain the content and not the float.</p>

<p>{{EmbedGHLiveSample("css-examples/flow/formatting-contexts/float.html", '100%', 720)}}</p>

<p>Creating a new <abbr title="Block Formatting Context">BFC</abbr> would contain the float. A typical way to do this in the past has been to set <code>overflow: auto</code> or set other values than the initial value of <code>overflow: visible</code>.</p>

<p>{{EmbedGHLiveSample("css-examples/flow/formatting-contexts/bfc-overflow.html", '100%', 720)}}</p>

<p>Setting <code>overflow: auto</code> created a new <abbr title="Block Formatting Context">BFC</abbr> containing the float. Our <code>&lt;div&gt;</code> now becomes a mini-layout inside our layout. Any child element will be contained inside it.</p>

<p>The problem with using <code>overflow</code> to create a new <abbr title="Block Formatting Context">BFC</abbr> is that the <code>overflow</code> property is meant for telling the browser how you wish to deal with overflowing content. There are some occasions in which you will find you get unwanted scrollbars or clipped shadows when you use this property purely to create a BFC. In addition, it is potentially not very readable for a future developer, as it may not be obvious why you used <code>overflow</code> for this purpose. If you do this, it would be a good idea to comment the code to explain.</p>

<h3 id="Explicitly_creating_a_BFC_using_display_flow-root">Explicitly creating a BFC using display: flow-root</h3>

<p>Using <code>display: flow-root</code> (or <code>display: flow-root list-item</code>) on the containing block will create a new <abbr title="Block Formatting Context">BFC</abbr> without any other potentially problematic side-effects.</p>

<p>{{EmbedGHLiveSample("css-examples/flow/formatting-contexts/bfc-flow-root.html", '100%', 720)}}</p>

<p>With <code>display: flow-root</code> on the {{HTMLElement("div")}}, everything inside that container participates in the block formatting context of that container, and floats will not poke out of the bottom of the element.</p>

<p>The name of the <code>flow-root</code> keyword refers to the fact that you're creating something that serves, in essence, like a new root element (like {{HTMLElement("html")}} does), given how the new context is created and its flow layout functions.</p>

<h2 id="Inline_formatting_contexts">Inline formatting contexts</h2>

<p>Inline formatting contexts exist inside other formatting contexts and can be thought of as the context of a paragraph. The paragraph creates an inline formatting context inside which such things as {{HTMLElement("strong")}}, {{HTMLElement("a")}}, or {{HTMLElement("span")}} elements are used on text.</p>

<p>The box model does not fully apply to items participating in an inline formatting context. In a horizontal writing mode line, horizontal padding, borders and margin will be applied to the element and push the text away left and right. However, margins above and below the element will not be applied. Vertical padding and borders will be applied but may overlap content above and below as, in the inline formatting context, the line boxes will not be pushed apart by padding and borders.</p>

<p>{{EmbedGHLiveSample("css-examples/flow/formatting-contexts/inline.html", '100%', 720)}}</p>

<h2 id="Other_formatting_contexts">Other formatting contexts</h2>

<p>This guide covers flow layout and is therefore not referring to other possible formatting contexts. As such, it is useful to understand that creating any kind of formatting context will change the way elements inside that formatting context behave. This behavior is always described in the specification and also here on MDN.</p>

<h2 id="Summary">Summary</h2>

<p>In this guide, we have looked in more detail at the block and Inline formatting contexts and the important subject of creating a block formatting context (<abbr title="Block Formatting Context">BFC</abbr>). In the next guide, we will find out <a href="/en-US/docs/Web/CSS/CSS_Flow_Layout/Flow_Layout_and_Writing_Modes">how normal flow interacts with different writing modes</a>.</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/Guide/CSS/Block_formatting_context">Block formatting context</a></li>
 <li><a href="/en-US/docs/Web/CSS/Visual_formatting_model">Visual Formatting Model</a></li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Box_Model">CSS Box Model</a></li>
</ul>
